<?php defined('SYSPATH') or die('No direct script access.');

class Controller_Handler_AdmAccounts extends Controller_Handler
{
        public function before() {
            $this->setAccessLevel(self::ACCESS_USER);
            parent::before();
        }
        
        public function action_getActivationForTeachers()
        {
            $facultyID = $this->post['facultyID'];
            $departmentsHandled = array(); $i = 0;
            $departments = Model_Departments::ofFaculty($facultyID);
            foreach ($departments as $department)
            {
                $i++; $j = 0;
                $accounts = Model_Teachers::getTeachersByDepartment($department['ID']);
                if ($accounts == null)
                    continue;
                $departmentsHandled[$i]['Name'] = $department['Name'];
                foreach ($accounts as $row)
                {
                    $accInfo = Model_Accounts::getAccountInfo($row['AccountID']);
                    if($code = $accInfo->get('Code'))
                    {
                        $j++;
                        $departmentsHandled[$i]['People'][$j]['LastName'] = $row['LastName'];
                        $departmentsHandled[$i]['People'][$j]['FirstName'] = $row['FirstName'];
                        $departmentsHandled[$i]['People'][$j]['SecondName'] = $row['SecondName'];
                        $departmentsHandled[$i]['People'][$j]['ActivationCode'] = $code;
                    }
                }
                if($j == 0)
                {
                    $departmentsHandled[$i] = array();
                    $i--;
                }
            }
            if($i > 0)
            {
                $File = PDFCreator::CreatePDF(
                        'pdf/activationTeacher',
                        'media/css/pdf/activationTemplate.css',
                        array(
                            'Departments' => $departmentsHandled, 
                            'System' => array(
                                'Title' => ASSEMBLY_SYSTEM_NAME, 
                                'Version' => ASSEMBLY_VERSION
                                )
                            ));
                $Headers = PDFCreator::GetHeaders($File, 'ActivationTeachers'.$facultyID);
                foreach ($Headers as $key => $value) {
                    $this->response->headers($key, $value);
                }
                $this->response->body($File);
            }
            else {
                throw HTTP_Exception::factory(400, 'No data found');
            }
        }
        
        public function action_getActivationForStudents()
        {
            $facultyID = $this->post['facultyID'];
            $gradeID = $this->post['gradeID'];
            $groupsHandled = array(); $i = 0;
            $groups = Model_Faculty::with($facultyID)->getGroups($gradeID);
            foreach ($groups as $group)
            {
                $i++; $j = 0;
                $accounts = Model_Students::ofGroup($group['ID']);
                if (empty($accounts))
                    continue;
                $groupsHandled[$i]['Grade'] = $gradeID;
                $groupsHandled[$i]['Num'] = $group['GroupNum'];
                $groupsHandled[$i]['Spec'] = $group['SpecName'];
                foreach ($accounts as $row)
                {
                    $accInfo = Model_Accounts::getAccountInfo($row['AccountID']);
                    if($code = $accInfo->get('Code'))
                    {
                        $j++;
                        $groupsHandled[$i]['People'][$j]['LastName'] = $row['Last'];
                        $groupsHandled[$i]['People'][$j]['FirstName'] = $row['First'];
                        $groupsHandled[$i]['People'][$j]['SecondName'] = $row['Second'];
                        $groupsHandled[$i]['People'][$j]['ActivationCode'] = $code;
                    }
                }
                if($j == 0)
                {
                    $groupsHandled[$i] = array();
                    $i--;
                }
            }
            if($i > 0)
            {
                $File = PDFCreator::CreatePDF(
                        'pdf/activationStudent',
                        'media/css/pdf/activationTemplate.css',
                        array(
                            'Groups' => $groupsHandled, 
                            'System' => array(
                                'Title' => ASSEMBLY_SYSTEM_NAME, 
                                'Version' => ASSEMBLY_VERSION
                                )
                            ));
                $Headers = PDFCreator::GetHeaders($File, 'ActivationStudents');
                foreach ($Headers as $key => $value) {
                    $this->response->headers($key, $value);
                }
                $this->response->body($File);
            }
            else {
                throw HTTP_Exception::factory(404, 'No data found');
            }
        }
}